var Fastbucks = Fastbucks || {};
Fastbucks.spinner = Fastbucks.spinner || {};

var timesOnce = timesOnce || {};

(function ($) {

    var saveConfig = function (params, path, name, projectKey, controls) {
        var jsonData = JSON.stringify(params);
        console.log("client data " + jsonData);
        $.ajax({
            type:"POST",
            cache:false,
            contentType:"application/json; charset=utf-8",
            url:contextPath + "/rest/fastbucks/latest/" + path + "/" + name + "/" + projectKey + "/config",
            data:jsonData,
            success:function (data, textStatus, jqXHR) {
                controls.hideEditMode();
            },
            error:function (jqXHR, textStatus, errorThrown) {
                AJS.messages.generic("#fastbucks-messages", {
                   title:"Error",
                   body: AJS.template.load("client-license-error-template").fillHtml({messageHtml:jqXHR.responseText})
                });
            }
        });
    }

    var getProjectParams = function ( $paramSection ) {

        var params = {};
        params.projectclient = AJS.escapeHtml($("#projectclient", $paramSection).val());
        params.projectissuestatus = AJS.escapeHtml($("#project-config-issue-status", $paramSection).val());
        params.projectrate = AJS.escapeHtml($("#projectrate", $paramSection).val());
        params.cronexpression = AJS.escapeHtml($("#project-config-scheduler-cron-field", $paramSection).val());
        params.billingcontact = AJS.escapeHtml($("#billingcontact", $paramSection).val());
        params.startdate = AJS.escapeHtml($("#project-config-scheduler-start-date-field").val());
        params.invoicetype = AJS.escapeHtml($("#invoicetype", $paramSection).val());

        return params;

    }

    var getControls = function($edit){
        var controls = {};
        controls.$editEl = $edit;
        controls.$cancel = $edit.nextAll(".fastbucks-config-cancel");
        controls.$test = $edit.nextAll(".fastbucks-test");
        controls.$paramSection = $edit.closest('span').next("form");
        controls.showEditMode = function () {
            controls.$editEl.text(AJS.I18n.getText('fastbucks.project.config.save'));
            controls.$paramSection.removeClass("hidden");
            controls.$paramSection.show();
            controls.$cancel.removeClass("hidden");
            controls.$cancel.show();
            controls.$test.hide();
        }

        controls.hideEditMode = function (){
            controls.$editEl.text(AJS.I18n.getText('fastbucks.project.config.edit'));
            controls.$paramSection.hide('slow');
            controls.$cancel.hide();
            controls.$test.show();

        }

        controls.isVisible = function (){
            return controls.$paramSection.is(":visible")
        }

        return controls;
    }

    AJS.toInit(function ($) {
            AJS.log("init fastbucks");
            $(".fastbucks-config-cancel").click(function (event) {
                var $edit = $(this).prev("button");
                var controls = getControls($edit);
                controls.hideEditMode();
            });
            $(".fastbucks-config").click(function (event) {
                event.preventDefault();
                var controls = getControls($(this));
                if (!controls.isVisible()) {
                    controls.showEditMode();
                } else {
                    var path = "client";
                    var name = $(this).closest('li').find('.clientname').text();
                    var params = [];
                    var i = 0;
                    var projectKey = $("meta[name=projectKey]").attr("content");
                    var projectId = $("meta[name=projectId]").attr("content");
                    $(".fastbucks-client-config-param", controls.$paramSection).each(function () {
                        params[i++] = { key:$(this).attr('id'), value: $(this).val() };
                    });
                    if ($(".fastbucks-project-config-param", controls.$paramSection).length > 0) {
                        params[i++] = getProjectParams( controls.$paramSection);
                        path = "project";
                        name = projectId;
                    }
                    saveConfig(params, path, name, projectKey, controls);
                }
            });

            var testConfig = function ($section, url) {
                $section.append("<div class='fastbucks-spinner'></div>");
                Fastbucks.spinner.start($section);
                $.ajax({url:url})
                    .done(function (data) {
                        Fastbucks.spinner.stop($section);
                        AJS.messages.generic("#fastbucks-messages", {
                           title:"Success",
                           body: AJS.template.load("client-result-template").fill({message:data.msg })
                        });
                    })
                    .fail(function (data, status, jqXHR) {
                        Fastbucks.spinner.stop($section);
                        AJS.messages.generic("#fastbucks-messages", {
                           title:"Error",
                           body: AJS.template.load("client-error-template").fill({message:data.responseText, status:data.status })
                        });
                    });
            };

            $("a.fastbucks-test-client").click(function (event) {
                event.preventDefault();
                var $paramSection = $(this).closest('span').next();
                var $client = $(this).closest('li').find('.clientname');
                var name = $client.text();
                var url = contextPath + "/rest/fastbucks/latest/client/" + name + "/test";
                var $clientSection = $client.parent();
                if ($paramSection.is(":visible")) {
                    $clientSection.append(AJS.template.load("client-result-template").fill({message:"Please save before test"}));
                    setTimeout(function () {
                        $(".result-success", $clientSection).hide('slow').remove();
                    }, 5000);
                    return;
                }
                testConfig($clientSection, url);
            });
            $("a.fastbucks-test-project").click(function (event) {
                event.preventDefault();
                var $paramSection = $(this).closest('span').next();
                var projectKey = $("meta[name=projectKey]").attr("content");
                var $projectSection = $(this).closest("li").find(".project-config-list-label");
                var url = contextPath + "/rest/fastbucks/latest/project/" + projectKey + "/test";
                if ($paramSection.is(":visible")) {
                    $projectSection.append(AJS.template.load("client-result-template").fill({message:"Please save before test"}));
                    setTimeout(function () {
                        $(".result-success", $projectSection).hide('slow').remove();
                    }, 5000);
                    return;
                }
                testConfig($projectSection, url);
            });

            $("#project-config-scheduler-cron-field-trigger").click( function(event ) {
                cronDialog.gotoPage(0);
                cronDialog.gotoPanel(0);
                cronDialog.show();

            });
            var cronDialog = new  AJS.Dialog({
                    width : 440,
                    height : 293,
                    id : "cron-dialog",
                    closeOnOutsideClick: true
                });

            cronDialog.addHeader(AJS.I18n.getText('fastbucks.project.config.cron.editor'));
            cronDialog.addPanel("Panel 1", "#fastbuckscroneditor", "panel-body");
            cronDialog.get("panel:0").setPadding(10);
            cronDialog.addButton("Done", function(dialog) {
                // dialog = This AJS.Dialog instance
                // page = The page of the dialog to which this button has been added
                // As of AUI 3.4:
                // Return true to allow the default action of this click event.
                // Return any other value to prevent the default action of this click event.
                var projectKey = $("meta[name=projectKey]").attr("content");
                var url = contextPath + "/rest/fastbucks/latest/project/" + projectKey + "/cron";
                $.post( url, $("form#fastbuckscroneditor").serialize())
                    .done( function( data ){
                        $("input#project-config-scheduler-cron-field").val( data.msg );
                        dialog.hide();
                        } )
                    .fail( function ( data ){
                        console.log( data );
                    } );
                return true;
                });
                cronDialog.addLink('cancel', function(dialog) {
                      // dialog = This AJS.Dialog instance
                      // page = The page of the dialog to which this button has been added
                      // As of AUI 3.4:
                      // Return true to allow the default action of this click event.
                      // Return any other value to prevent the default action of this click event.
                    dialog.hide();
                    });

            if (! timesOnce)
            {
                timesOnce = new Object();
            }
            timesOnce["fastbucks."] = true ;

//            methods from croneditor.js
            switchToDaysOfMonth('fastbucks.');
            switchToOnce('fastbucks.', false);

            console.log( $("#project-config-scheduler-start-date-field").html());
            Calendar.setup({
                        singleClick: true,
                        align: "Bl",
                        firstDay: AJS.params.firstDay,
                        button: "project-config-scheduler-start-date-trigger",
                        inputField: "project-config-scheduler-start-date-field",
                        currentMillis: AJS.params.currentMillis,
                        useISO8061: AJS.params.useISO8061,
                        ifFormat: AJS.params.dateFormat
                    });
        }
    );

    Fastbucks.spinner.start = function ( $element ) {
        Raphael.spinner($(".fastbucks-spinner", $element)[0], 8, "#666");
        $(".fastbucks-spinner", $element).show();
    } ;
    Fastbucks.spinner.stop = function( $element ){
        $(".fastbucks-spinner", $element).hide('slow').remove();
    };



})(AJS.$)